Imports System

Public Class GridRefDist
  Inherits System.Web.UI.Page
  Dim oAtlas As New soapatlas_dotnet.SOAPAtlas

  ' --- Enter your username and password here ---
  Const sLogin As String = "MyUsername"
  Const sPassword As String = "MyPassword"
  Const sModule As String = "ah21_uk"
  ' ---------------------------------------------

  Dim sSessionId As String

#Region " Web Form Designer Generated Code "

  'This call is required by the Web Form Designer.
  <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

  End Sub
  Protected WithEvents lblTitle As System.Web.UI.WebControls.Label
  Protected WithEvents btnLookup As System.Web.UI.WebControls.Button
  Protected WithEvents txtPostcode1 As System.Web.UI.WebControls.TextBox
  Protected WithEvents txtEasting1 As System.Web.UI.WebControls.TextBox
  Protected WithEvents txtNorthing1 As System.Web.UI.WebControls.TextBox
  Protected WithEvents lblEasting1 As System.Web.UI.WebControls.Label
  Protected WithEvents lblNorthing1 As System.Web.UI.WebControls.Label
  Protected WithEvents lblPostcode1 As System.Web.UI.WebControls.Label
  Protected WithEvents lblNorthing2 As System.Web.UI.WebControls.Label
  Protected WithEvents lblEasting2 As System.Web.UI.WebControls.Label
  Protected WithEvents lblPostcode2 As System.Web.UI.WebControls.Label
  Protected WithEvents txtPostcode2 As System.Web.UI.WebControls.TextBox
  Protected WithEvents txtEasting2 As System.Web.UI.WebControls.TextBox
  Protected WithEvents txtNorthing2 As System.Web.UI.WebControls.TextBox
  Protected WithEvents lblMiles As System.Web.UI.WebControls.Label
  Protected WithEvents txtMiles As System.Web.UI.WebControls.TextBox
  Protected WithEvents lblKm As System.Web.UI.WebControls.Label
  Protected WithEvents txtKm As System.Web.UI.WebControls.TextBox
  Protected WithEvents txtSessionId As System.Web.UI.WebControls.TextBox
  Protected WithEvents txtStatus As System.Web.UI.WebControls.TextBox
  Protected WithEvents lblStatus As System.Web.UI.WebControls.Label
  Protected WithEvents txtGrid1 As System.Web.UI.WebControls.TextBox
  Protected WithEvents lblGrid1 As System.Web.UI.WebControls.Label
  Protected WithEvents txtGrid2 As System.Web.UI.WebControls.TextBox
  Protected WithEvents lblGrid2 As System.Web.UI.WebControls.Label

  'NOTE: The following placeholder declaration is required by the Web Form Designer.
  'Do not delete or move it.
  Private designerPlaceholderDeclaration As System.Object

  Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
    'CODEGEN: This method call is required by the Web Form Designer
    'Do not modify it using the code editor.
    InitializeComponent()
  End Sub

#End Region

  Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' Do not expect "100-Continue" HTTP Header
    System.Net.ServicePointManager.Expect100Continue = False

    ' If not logged in, log in and display version info
    If txtSessionId.Text.Length = 0 Then
      Dim oLogin As New soapatlas_dotnet.login
      oLogin.login1 = sLogin
      oLogin.password = sPassword
      txtSessionId.Text = oAtlas.login(oLogin)

      Dim oVersion As New soapatlas_dotnet.version
      oVersion.session_id = txtSessionId.Text
      oVersion.module_id = sModule
      Dim oVersionAtlas As soapatlas_dotnet.version_atlas = oAtlas.version(oVersion)
      txtStatus.Text = oVersionAtlas.ATLAS & " | " & oVersionAtlas.SERVER & " | " & oVersionAtlas.PAF
    End If

    sSessionId = txtSessionId.Text
  End Sub

  Function GetGridRef(ByRef postcode As String, ByRef easting As String, ByRef northing As String, ByRef grid As String) As String
    Try
      Dim oAh21 As New soapatlas_dotnet.ah21
      oAh21.session_id = sSessionId
      oAh21.input = postcode
      oAh21.data = "PZON_X, PZON_Y, POSTCODE"
      Dim oAddresses As soapatlas_dotnet.arrayOfAddress = oAtlas.ah21(oAh21)

      If oAddresses.address.Length > 0 Then
        easting = oAddresses.address(0).PZON_X
        northing = oAddresses.address(0).PZON_Y
        postcode = oAddresses.address(0).POSTCODE

        Select Case Left(postcode, 2)
          Case "BT"
            grid = "Irish"
          Case "GY", "JE"
            northing = "-" & northing
            grid = "British"
          Case Else
            grid = "British"
        End Select
        GetGridRef = ""
      Else
        GetGridRef = "No match found"
      End If
    Catch
      GetGridRef = Err.Description
    End Try
  End Function

  Function GetDistance(ByVal e1 As Integer, ByVal n1 As Integer, ByVal e2 As Integer, ByVal n2 As Integer) As Double
    GetDistance = Math.Sqrt(((e1 - e2) ^ 2) + ((n1 - n2) ^ 2)) / 1000
  End Function

  Private Sub btnLookup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLookup.Click
    Dim status1 As String = ""
    Dim status2 As String = ""
    Dim easting1 As String = ""
    Dim northing1 As String = ""
    Dim easting2 As String = ""
    Dim northing2 As String = ""
    Dim miles As Double = 0
    Dim kilometres As Double = 0

    btnLookup.Enabled = False
    txtEasting1.Text = ""
    txtNorthing1.Text = ""
    txtGrid1.Text = ""
    txtEasting2.Text = ""
    txtNorthing2.Text = ""
    txtGrid2.Text = ""
    txtMiles.Text = ""
    txtKm.Text = ""

    Try
      If Len(txtPostcode1.Text) > 0 Then
        status1 = GetGridRef(txtPostcode1.Text, easting1, northing1, txtGrid1.Text)
      End If

      If Len(txtPostcode2.Text) > 0 Then
        status2 = GetGridRef(txtPostcode2.Text, easting2, northing2, txtGrid2.Text)
      End If

      If (status1 = "") And (status2 = "") And (txtGrid1.Text = txtGrid2.Text) And Len(txtGrid1.Text) > 0 Then
        kilometres = GetDistance(CInt(easting1), CInt(northing1), CInt(easting2), CInt(northing2))
        miles = Math.Round(kilometres / 1.609344, 2)
        kilometres = Math.Round(kilometres, 2)
      End If

      txtEasting1.Text = CStr(easting1)
      txtNorthing1.Text = CStr(northing1)
      txtEasting2.Text = CStr(easting2)
      txtNorthing2.Text = CStr(northing2)
      txtMiles.Text = CStr(miles)
      txtKm.Text = CStr(kilometres)
      txtStatus.Text = status1

      If Len(status1) > 0 And Len(status2) > 0 Then
        txtStatus.Text = txtStatus.Text & " | "
      End If
      txtStatus.Text = txtStatus.Text & status2
    Finally
      btnLookup.Enabled = True
    End Try
  End Sub
End Class
